open Figure
open Couleurs


(** Affichage de figures dans la fenetre graphique. *)



(* carre_plein_rgb affiche un carr sur un drawable *)
let carre_plein_rgb  
  (abs:int) (ord:int) (unite:int) (visible:bool) 
  (drawing :([ `window] GDraw.drawable)) 
  (rgb : int*int*int ) =
  drawing#set_foreground (`RGB rgb);
  drawing#rectangle  ~filled:(visible) ~x:(abs) ~y:(ord) ~width:unite ~height:unite () ;
(* POUR TEST *)
  match !Parametres.svgoutput with
  | None -> ()
  | Some s ->  print_endline(ToSVG.rect abs ord unite unite) ;;

(*
(* x, y dx et dy sont donnees en coordonnes dans le plan d'affichage,
 modulo unite *)
let draw_line (x:int) (y:int) 
    (unite:int) 
    (dx:int) (dy:int) 
    (drawing: 'a GDraw.drawable) 
    (c:i_couleur ) =
  let centre_x = (* pour etre au centre du carre *)
    x * unite + (unite/2)
  and centre_y =
    y * unite + (unite/2)
  in
    begin
      drawing#set_foreground (`RGB c); (*On lui donne sa couleur*)
      drawing#line  centre_x centre_y (centre_x + (dx*unite)) (centre_y +(dy*unite))  
    end
*)

(* x, y x' et y' sont donnees en coordonnes dans le plan d'affichage *)
let draw_line' (x:int) (y:int) 
    (x':int) (y':int) 
    (drawing:[ `window] GDraw.drawable) 
    (c:i_couleur ) =

    begin
      drawing#set_foreground (`RGB c); (*On lui donne sa couleur*)
      drawing#line  x y  x' y'  
    end

(* a deplacer dans fcts_hexa *)
let make_six2 x y hauteur long = 
  [ (x,y); 
    (x+hauteur, y-long/2);
    (x+2*hauteur, y);
    (x+2*hauteur, y+long);
    (x+hauteur, y+ 3 * long / 2 );
    (x, y+long) ] ;;
    
(****************************************************************)
(*rempli_hexa2 :                                                *)
(****************************************************************) 




(* fonction qui remplit un hexagone avec RGB *)
let rempli_hexa2 (x:int) (y:int) (long:int) 
    (drawing: 'a GDraw.drawable) (c:i_couleur ) =
  let f_long = float_of_int long in
  let  hauteur =  (sqrt(3.0))*.f_long/.2.0 in     
    drawing#set_foreground (`RGB c); (*On lui donne sa couleur*)
    drawing#polygon ~filled:true (make_six2 x y (int_of_float hauteur) long)
;;




(* affiche une figure dans une drawable *)
let affiche_figure drawing = function
    Carre ( (x,y), cote, coul) ->
      carre_plein_rgb  x y cote true drawing coul
  | Ligne ( (x,y), (x',y'), coul) ->
      draw_line' x y x' y' drawing coul
  | Hexagone ( (x,y), cote, coul) ->
      rempli_hexa2 x y cote drawing coul
