open Types
open GMain
open Couleurs
open Liste
open Fcts_grille
open Fcts_hexa

exception Erreur of string



(**********************definition de la l'objet self**************************)

class callbacks (type_maille, (scene:Types.scene))=

object(self)  inherit Project5_glade_callbacks.default_callbacks

(************definition des variables mutables**************)
(* result            : corespond    a la liste de scenes   *)
(*                     recuperees par le parser,c'est une  *)
(*                       (string*int) list list list       *) 
(*type_maille : valeur  definissant le type du             *)
(*                maillage (grille,maillage hexagonal)     *)
(* champ1 et champ2: correspondent aux 2 champs que l'on   *)
(*                    veut visualiser a l'ecran            *)
(* coul_fond : couleur de fond                             *)
(* quad : booleen qui dit si le maillage doit etre visible *)
(*         ou pas                                          *)
(* maille_type2 : booleen disant le type du maillage hexag *)
(* red1,green1,blue1: valeurs des coeffs RGB pour le champ1*)
(* red2,green2,blue2: valeurs des coeffs RGB pour le champ2*)
(* red_grille, green_grille, blue_grille: valeurs des      *)
(*                       coeffs pour la couleur du maillage*)
(* unite : longueur d'un cote d'un carre du maillage       *)
(* unite2: longueur d'un cote d'hexagone                   *)
(* deja_passe: valeur booleene disant si le bouton play a  *)
(*             deja ete presse                             *)
(* visible_champ1:valeur booleene disant si le champ1 doit *)
(*                etre visible                             *)
(* visible_champ2:valeur booleene disant si le champ2 doit *)
(*                etre visible                             *)
(***********************************************************)


val result  = ref []

val mutable save_film = []
val mutable lecture_terminee = false
val mutable last_scene = scene

val mutable champ1 =""
val mutable champ2 =""
val mutable champ3 =""
val mutable quad = false
val mutable maille_type2 = false

val mutable red1 = 1.00
val mutable green1 = 0.00
val mutable blue1 = 0.00

val mutable red2 = 0.00
val mutable green2 = 1.00
val mutable blue2 = 0.00

val mutable red3 = 0.00
val mutable green3 = 0.00
val mutable blue3 = 1.00

val mutable red_grille=0.00
val mutable green_grille=0.00
val mutable blue_grille=0.00

val mutable red_fond=1.00
val mutable green_fond=1.00
val mutable blue_fond=1.00

val mutable unite = 20
val mutable unite2 = 20.00

val mutable deja_passe= false
val mutable le_timer = None

val mutable visible_champ1 = true
val mutable visible_champ2 = false
val mutable visible_champ3 = false


val mutable drawing_memor   = None
val mutable drawing_tmp     = None
val mutable drawing_back    = None

(*************************************************)
(*    PARTIE DE ANTOINE                          *)
(*************************************************)

val mutable pmap               = None
val mutable gc                 = None
val mutable sz                 = None
val mutable theRefBkgPixmap    = None
val mutable bgFileName         = ""             (*mettre le path d'un fichier XPM !!!*)
val mutable image_counter      = 0             
val mutable image_counter_init = 0
val mutable savedFileName      = "xout"
val mutable savedFileExt       = ".png"


method pixmap =
 match pmap with
    None -> raise (Erreur "Pixmap non initialise")
  | Some p ->  p

method gContext =
 match gc with
    None -> raise (Erreur "Graphic context non initialise")
  | Some g ->  g

method size =
 match sz with
    None -> raise (Erreur "Sz non initialise")
  | Some s ->  s

method drawing =
 match drawing_memor with
    None -> raise (Erreur "Fenetre de dessin non initialisee")
  | Some d ->  d

method background =
 match theRefBkgPixmap with
    None -> raise (Erreur "Fenetre de dessin non initialisee")
  | Some b ->  b

method withBackground =
 match theRefBkgPixmap with
    None -> false
  | Some _ -> true

method new_drawing =
  begin
    self#top_window1#dessin#misc#realize ();
    let window = (self#top_window1#dessin#misc#window) in
    let (w,h) = Gdk.Window.get_size window in
    let pixmap = Gdk.Pixmap.create ~window:window ~width:w ~height:h  () in
    let pp = new GDraw.drawable pixmap in
      pmap            <- Some(pixmap) ;
      drawing_memor   <- Some(pp) ;
      gc              <- Some(Gdk.GC.create window) ;
      sz              <- Some(w,h) ;
      theRefBkgPixmap <- (
	if (bgFileName = "") 
	then None 
	else Some(GDraw.pixmap_from_xpm bgFileName ()) 
      ) ;
  end


method refresh = 
  Gdk.Draw.pixmap 
    self#top_window1#dessin#misc#window 
    self#gContext 
    self#pixmap



(************************************)
(* Quand on clic sur le bouton play *)
(************************************)
method on_button_play_clicked () =
  begin
    match le_timer with 
      | Some _  -> () (* lecture deja en cours *)
      | None ->
    deja_passe <- true; (*on a presse le bouton play ,donc on met le booleen a true*)


    (* on regarde combien vaut l'unite de mesure pour le dessin *)
    (let unit = self#top_window1#spinbutton_unite#text in 
       if(unit<>"") then 
	 begin
           unite <- (int_of_string unit);    (* unite va nous servir pour le maillage carre*)
           unite2 <- (float_of_string unit)  (* unite2 va nous servir pour le maillage hexagonal*)
	 end);
    
    (* on regarde si le quadrillage doit etre dessin *)
    
    quad <- self#top_window1#checkbutton_quadrillage#active;
  
    (* on regarde le type de maillage pour un maillage hexagonal *)
    maille_type2 <- self#top_window1#checkbutton_type_hexa#active;
    
    
    (*Mise a jour des couleurs*)
    (*Pour les 4 prochains  paragraphes,on regarde pour les 3 coeffs de couleurs(rouge,vert,bleu)
      si il y a du text dans l'entree,
      dans ce cas on remplace les anciennes valeurs par les nouvelles*)
    
      (***********couleurs pour le premier champ***********)
      (let rouge1 = self#top_window1#entry_rouge1#text in
	 if(rouge1<>"") then red1 <- (float_of_string rouge1));

      (let vert1 = self#top_window1#entry_vert1#text in
	 if(vert1<>"") then green1 <- (float_of_string vert1));

      (let bleu1 = self#top_window1#entry_bleu1#text in
	 if(bleu1<>"") then blue1 <- (float_of_string bleu1));
      
      (***********couleurs pour le deuxieme champ***********)
      (let rouge2 = self#top_window1#entry_rouge2#text in
	 if(rouge2<>"") then red2 <- (float_of_string rouge2));

      (let vert2 = self#top_window1#entry_vert2#text in
	 if(vert2<>"") then green2 <- (float_of_string vert2));

      (let bleu2 = self#top_window1#entry_bleu2#text in
	 if(bleu2<>"") then blue2 <- (float_of_string bleu2));
    
(***********couleurs pour le troiseme champ***********)
 let rouge3 = self#top_window1#entry_rouge3#text in
if(rouge3<>"") then red3 <- (float_of_string rouge3);

  let vert3 = self#top_window1#entry_vert3#text in
if(vert3<>"") then green3 <- (float_of_string vert3);

  let bleu3 = self#top_window1#entry_bleu3#text in
if(bleu3<>"") then blue3 <- (float_of_string bleu3);

(***********couleurs pour la grille***********)
 let rouge_g = self#top_window1#entry_rouge_grille#text in
if(rouge_g<>"") then red_grille <- (float_of_string rouge_g);

  let vert_g = self#top_window1#entry_vert_grille#text in
if(vert_g<>"") then green_grille <- (float_of_string vert_g);

  let bleu_g = self#top_window1#entry_bleu_grille#text in
if(bleu_g<>"") then blue_grille <- (float_of_string bleu_g);

(***********couleurs pour le fond***********)
 let rouge_f = self#top_window1#entry_rouge_fond#text in
if(rouge_f<>"") then red_fond <- (float_of_string rouge_f);

  let vert_f = self#top_window1#entry_vert_fond#text in
if(vert_f<>"") then green_fond <- (float_of_string vert_f);

  let bleu_f = self#top_window1#entry_bleu_fond#text in
if(bleu_f<>"") then blue_fond <- (float_of_string bleu_f);


    (*On met a jours les valeurs des 2 champs de la meme maniere que precedement *)
    (* il s'agit des champs que l'on veut visualiser *)
    (let cha1 = (self#top_window1#combo_champs1#entry#text) in
       if(cha1<>"") then champ1 <- cha1);
    (let cha2 = (self#top_window1#combo_champs2#entry#text) in
       if(cha2<>"") then champ2 <- cha2);
    (let cha3 = (self#top_window1#combo_champs3#entry#text) in
       if(cha3<>"") then champ3 <- cha3);


    (* Nous permet de faire dfiler les scenes une par une avec le temps choisi,
     * on applique la methode dessiner a chacune des scenes c'est a dire a chaque element de la liste*)
    (* Sachant qu'une scene est une data list et donc 
     *  result est une data list list  *) 

    if save_film  = [] (*il s'agit de la premire iage  afficher *)
    then  begin
      self#dessiner (scene:Types.scene) ; (* on affiche l'image parsee au demarrage *)
      save_film <-  [scene] ; 
      last_scene <-  scene 
    end ;

(* version fonctionnant uniquement avec le post-mortem *)
    let rappel_dessine = fun () -> match !result with
	
	[]-> 
	  begin
	    prerr_endline "fin" ;
	    image_counter <- image_counter_init ;
	    result := save_film ;
	    le_timer <- None ;
	    false 
	  end	    
	    
      | s :: q ->
	  begin 
	    self#dessiner s ;
	    result:=q ;
	    last_scene <-  s ;
	    true 
	  end

(* version fonctionnant avec le temps reel *)
(* parser, stocker et afficher *)
    and rappel_dessine_real_time = fun () ->
      try 
	begin
	  let next_scene = 
	     Parser.scene Lexer.vocab Parametres.lexbuf 
	      
	  in
	    self#dessiner next_scene ;
	    save_film <-  next_scene :: save_film ; 
	    last_scene <-  next_scene ;
	    true
	end
	    
      with 
	  Types.End_Of_File ->
	    begin 
	      prerr_endline "fin de fichier" ;
	      save_film <- List.rev save_film ;
	      prerr_endline (string_of_int (List.length save_film) ^ " images lues.");
	      result := save_film ;
	      lecture_terminee <- true ;
	      le_timer <- None ;
	      false 
	    end
	| Parsing.Parse_error -> begin prerr_endline "erreur de syntaxe" ; false end
	    
    in



      (* s'il s'agit de la premiere lecture, il faut parser et memoriser au fur et a  mesure *)
      (* sinon, il faut juste afficher ce qui a ete memorise *)
    let f = if lecture_terminee then rappel_dessine else rappel_dessine_real_time
    in
      f () ;
      le_timer <- Some ( Timeout.add 
			   ~ms:!Parametres.refreshSpeed 
			   ~callback: f) 
	
(* http://developer.gnome.org/doc/API/gtk/gtk-general.html#GTK-TIMEOUT-ADD *)
        
  end (* end method *)

(* methodes d'affichage de grilles *)

method draw_grid_rect coul taille unite = 
  begin 
    self#drawing#set_foreground (`RGB  coul);
    init_ligne   taille unite self#drawing;
    init_colonne taille unite self#drawing;
  end

method draw_grid_hexa coul taille unite =
  begin
    self#drawing#set_foreground (`RGB  coul);
    let f = 
      if maille_type2 
      then draw_maillage_hexa1 
      else draw_maillage_hexa2 
    in f 0.0 (unite/.2.0)  unite  taille  self#drawing
  end

(***************************************************)
(* Quand on coche le bouton visible avec la souris *)
(***************************************************)

method on_checkbutton_quadrillage_clicked () =

  begin
    (*on met a jour le booleen quad*)
    quad <- self#top_window1#checkbutton_quadrillage#active ;
    
    (if  (quad) then 
      
      
      (* On calcule les couleurs pour RGB avec les coeffs recuperes,
       * il faut les multiplier par 65535 pour avoir les des couleurs coherentes avec RGB*) 
      let coul_grille= int_of_float3( mult_couleur 65535.0 (red_grille,green_grille, blue_grille)) 
	
      and  t = 
	    let (x_max,y_max) =(max_maille [scene])
	    and (x_min,y_min) =(min_maille [scene])
	    in (max (x_max-x_min)  (y_max-y_min))+1   
      in
	
	match type_maille with
	    
	  | Grille ->  self#draw_grid_rect coul_grille t unite
	      
	  | Hexa ->   self#draw_grid_hexa coul_grille t unite2
	      
    ) ;
    self#maj();
	      
  end
    
    

(*****************************************)
(* Quand on coche visible pour le champ1**)
(*****************************************)
method on_checkbutton_champ1_clicked () =
let visible1 = self#top_window1#checkbutton_champ1#active in  visible_champ1<- visible1 ;
self#maj();


(*****************************************)
(* Quand on coche visible pour le champ2**)
(*****************************************)
method on_checkbutton_champ2_clicked () =
let visible2 = self#top_window1#checkbutton_champ2#active in  visible_champ2<- visible2 ;
self#maj();


(*****************************************)
(* Quand on coche visible pour le champ3**)
(*****************************************)
method on_checkbutton_champ3_clicked () =
let visible3 = self#top_window1#checkbutton_champ3#active in  visible_champ3<- visible3 ;
self#maj();


method on_combo_entry1_changed () =
 self#maj(); 

method on_combo_entry2_changed () =
 self#maj(); 

method on_combo_entry3_changed () =
 self#maj(); 



(******************************************)
(* Quand on clicke sur le bouton pause  **)
(******************************************)
method on_button_pause_clicked () = 
  match le_timer with
      Some t -> begin le_timer <- None ;  Timeout.remove t end
    | None -> ()

(******************************************)
(* Quand on clicke sur le bouton stop   **)
(******************************************)
method on_button_stop_clicked () = 
  begin
    (  match le_timer with
	Some t -> begin le_timer <- None ;  Timeout.remove t end
      | None -> ()
    )  ;
    if not lecture_terminee then
      begin
	save_film <- List.rev save_film ;
	prerr_endline (string_of_int (List.length save_film) ^ " images lues.");
	lecture_terminee <- true ;
      end ;
    result := save_film ;    
  end

(******************************************)
(* Quand on clicke sur le boutton quitter**)
(******************************************)
method on_button_quitter_clicked () = exit 0


(****************************************)
(* Quand on clicke sur le boutton close**)
(****************************************)
method  on_window1_remove (destroy) = exit 0






(********************methode qui va etre appelee pour chaque scene********************)
(*on dessine dans la fenetre window1,on regarde d'abord le type de maille(2 choix : grille ou hexa*)

method dessiner t =
  let  coul_grille=
    int_of_float3( mult_couleur 65535.0 (red_grille,green_grille,blue_grille))
  in
    
    (
      
      (*On calcule alors la taille de notre maillage*)
      let (x_max,y_max) =(max_maille [scene])
      and (x_min,y_min) =(min_maille [scene])
      in
      let tail=(max (x_max-x_min)  (y_max-y_min))+1   
      in  
      let figures = match type_maille with                   
	  Grille -> Fcts_grille.figures
	| Hexa -> Fcts_hexa.figures in
      let f =                   
	  	    (fun 
	       ch unite (c:Couleurs.f_couleur) 
	       xmin ymin (s:Types.scene) drawing -> 
		 let fig_list = figures  ch unite c xmin ymin s in
		   List.iter (Affichage.affiche_figure drawing) fig_list)

      in
	
	begin   
	  self#eff_ecran; (*On efface le fond d'ecran*)
	  self#effacer();    (*On efface le fond du maillage*)
	  
	  (*On regarde si les champs sont visibles ou non et les trace si il le sont*)
	  if visible_champ1 
	  then f
	    champ1 unite 
	    (red1, green1, blue1) 
	    x_min y_min 
	    t self#drawing ;
	  
	  if visible_champ2 
	  then f
	    champ2 unite 
	    (red2, green2, blue2) 
	    x_min y_min t 
	    self#drawing ;
	  
	  if visible_champ3 
	  then f 
	    champ3 unite 
	    (red3, green3, blue3) 
	    x_min y_min 
	    t self#drawing ;
	  
	  if quad 
	  then   match type_maille with                   
	      Grille -> self#draw_grid_rect coul_grille tail unite
	    | Hexa -> self#draw_grid_hexa coul_grille tail unite2
		
        end
	  
    ) ;
    self#refresh ;
    if !Parametres.capture then self#screenshot
      
method eff_ecran =
  carre_plein 0 0 1100 true self#drawing "gray" ;
  if (self#withBackground) then self#drawing#put_pixmap ~x:0 ~y:0 self#background#pixmap
    
(***methode qui va servir a mettre a jour le fond du maillage
    * et aussi toutes les autres couleurs 
    * rendant possible le choix dynamique des couleurs pendant l'execution du programme***)
    
method effacer() = 
  
  (* --------------------------- *)
  (* initialisation des couleurs *)
  (* --------------------------- *)
  let  rouge_f = self#top_window1#entry_rouge_fond#text
  and vert_f = self#top_window1#entry_vert_fond#text
  and bleu_f = self#top_window1#entry_bleu_fond#text
  and cha1 = (self#top_window1#combo_champs1#entry#text) 
  and  cha2 = (self#top_window1#combo_champs2#entry#text)
  and  cha3 = (self#top_window1#combo_champs3#entry#text)
  and  unit = self#top_window1#spinbutton_unite#text in 
    if(unit<>"") then 
      begin
        unite <- (int_of_string unit);
        unite2 <- (float_of_string unit)
      end;
    
    (*Entre chaque image,on regarde si il y a eu du changement:*)
    (*pour les deux champs*) 
    if(cha1<>"") then champ1 <- cha1;
    if(cha2<>"") then champ2 <- cha2;
    if(cha3<>"") then champ3 <- cha3;
    (*pour les couleurs des deux champs*)
    
    (*pour les couleurs du fond*)
    if(rouge_f<>"") then red_fond <- (float_of_string rouge_f) ;
    if(vert_f<>"") then green_fond <- (float_of_string vert_f) ;
    if(bleu_f<>"") then blue_fond <- (float_of_string bleu_f) ;
    
    (*pour les couleurs pour le premier champ*)
    let rouge1 = self#top_window1#entry_rouge1#text in
    if(rouge1<>"") then red1 <- (float_of_string rouge1);
    let vert1 = self#top_window1#entry_vert1#text in
    if(vert1<>"") then green1 <- (float_of_string vert1);
    let bleu1 = self#top_window1#entry_bleu1#text in
    if(bleu1<>"") then blue1 <- (float_of_string bleu1);

    (*pour les couleurs du deuxieme champ*)
    let rouge2 = self#top_window1#entry_rouge2#text in
    if(rouge2<>"") then red2 <- (float_of_string rouge2);
    let vert2 = self#top_window1#entry_vert2#text in
    if(vert2<>"") then green2 <- (float_of_string vert2);
    let bleu2 = self#top_window1#entry_bleu2#text in
    if(bleu2<>"") then blue2 <- (float_of_string bleu2);

(*pour les couleurs du troisieme champ*)
    let rouge3 = self#top_window1#entry_rouge3#text in
    if(rouge3<>"") then red3 <- (float_of_string rouge3);
    let vert3 = self#top_window1#entry_vert3#text in
    if(vert3<>"") then green3 <- (float_of_string vert3);
    let bleu3 = self#top_window1#entry_bleu3#text in
    if(bleu3<>"") then blue3 <- (float_of_string bleu3);

    (*pour les couleurs pour la grille*)
    let rouge_g = self#top_window1#entry_rouge_grille#text in
    if(rouge_g<>"") then red_grille <- (float_of_string rouge_g);
    let vert_g = self#top_window1#entry_vert_grille#text in
    if(vert_g<>"") then green_grille <- (float_of_string vert_g);
    let bleu_g = self#top_window1#entry_bleu_grille#text in
     if(bleu_g<>"") then blue_grille <- (float_of_string bleu_g);
     
     (* --------------------------------- *)
     (* fin d'initialisation des couleurs *)
     (* --------------------------------- *) 


    (*on efface ensuite la derniere image*)    
(*  (let taille' = match type_reperage with 
       Coord  -> taille_calculee | Seq taille -> taille in
     begin
       
       match type_maille with
	   Grille-> (efface_grille unite taille' red_fond green_fond blue_fond self#drawing);  (*C'est une grille*)     
	 | Hexa ->if(maille_type2)
	   then
	     (*C'est un maillage hexagonal du deuxieme type*)
	     (efface_hexa1  unite2 taille' red_fond green_fond blue_fond  self#drawing)
	   else
	     (*C'est un maillage hexagonal du premier type*)
	     (efface_hexa2  unite2 taille' red_fond green_fond blue_fond  self#drawing) 
     end           
     )*)
    
(*********************)
(* Quand coche type2**)
(*********************)  
method  on_checkbutton_type_hexa_clicked() =
 let type2= self#top_window1#checkbutton_type_hexa#active 
 in maille_type2 <- type2; (*On met a jour type2*)
self#maj();

(**************methode qui appelle dessiner*****************)

method maj () = 
  let window = (self#top_window1#dessin#misc#window) in
  let (w,h) = Gdk.Window.get_size window in
    begin
      (if (w,h) <> self#size then
         (* Si la taille de la fentre a t modifie, *)
         (* il faut galement modifier celle du pixmap *)
         let pixmap = Gdk.Pixmap.create ~window:window ~width:w ~height:h () in
           pmap          <- Some(pixmap) ;
           drawing_memor <- Some(new GDraw.drawable pixmap) ;
           sz            <- Some(w,h)
      );
      (self#dessiner last_scene )
    end


method on_dessin_expose_event (event: GdkEvent.Expose.t) =
  (*pour rafraichir la derniere image si la fenetre est recouverte par une autre ou modifie*)
  self#maj() ;
  false
      

method screenshot =
  let save_image name =
    print_endline ("Construction de l'image: "^name^" ... ");
    flush stdout;
    let (w,h) = self#size in
    let raw = Gdk.Image.get self#pixmap ~x:0 ~y:0 ~width:w ~height:h in
    let visual = Gdk.Image.get_visual raw in
    let image = Rgb24.create w h in
      (* On enregistre dans image chaque pixel de la fentre *)
      for i = 0 to w - 1 do
	for j = 0 to h - 1 do
	  (* FIXME : la methode de transformation des pixel en RGB marche pas *)
	  let pixel = (Gdk.Image.get_pixel raw ~x:i ~y:j) in
	  let b = pixel mod 256 
	  and g = (pixel / 256) mod 256  
	  and  r =  (pixel / (256*256)) mod 256  in
	  (*let (rr,gg,bb) = Gdk.Truecolor.color_parser visual pixel in
	  let (r,g,b) = (rr*256/65536,gg*256/65536,bb*256/65536) in*)
	    begin 
	      Rgb24.set image i j (*h-1-j*) {Color.r = r; Color.g = g; Color.b = b};
	      if i=0 && j=0 
	      then (print_endline ((string_of_int pixel) ^ " : " ^
				     (string_of_int r) ^ " " ^ (string_of_int g) ^
				     " "^ (string_of_int b)) ;
		    flush stdout);
	    end
	done;
      done;
      try
	print_endline ("Image "^name^" done ");
	print_endline ("Enregistrement de l'image: "^name^" ... ");
	flush stdout;
	Images.save  name None [] (Images.Rgb24 image);
	print_endline "Ok ;-)";
	flush stdout
      with
	  e -> print_endline (Printexc.to_string e)
  in
    save_image (savedFileName^(string_of_int image_counter)^ savedFileExt) ;
    image_counter <- image_counter + 1
      
end
  
