open GMain
open Couleurs
open Figure
(** Toutes les fonctions portant sur une grille *)

(** fonction permettant de tracer les lignes de la grille,
   n etant le nombre de cases souhaitees et 
   u l'unite et 
   drawing un objet*)


let init_ligne n u drawing =
   let rec trace_ligne taille unite (x1,x2)= 
            let hauteur = taille*unite 
              in
            match (x1,x2)    
            with
    |(0, x) when x=hauteur->(drawing#line 
			       ~x:(0) ~y:(hauteur)  
                               ~x:(hauteur) ~y:(hauteur))
    |(abs , ord) -> (drawing#line ~x:(abs) ~y:(ord)  
                                  ~x:((abs+hauteur)) ~y:(ord));
                     trace_ligne taille unite (abs,(ord+unite))
in
  trace_ligne n u (0,0);;

(** fonction permettant de tracer les colonnes de la grille et 
   ayant les memes arguments que la fonction precedente*)

let init_colonne n u drawing=
   let rec trace_col taille unite (x1,x2)= 

            let hauteur = taille*unite 
              in
            match (x1,x2)    
            with
    |(x, 0) when x=hauteur->(drawing#line ~x:(hauteur) ~y:(0)  
                                                               ~x:(hauteur) ~y:(hauteur))
    |(abs , ord) -> (drawing#line ~x:(abs) ~y:(ord)  
                                  ~x:(abs) ~y:(ord+hauteur);
                     trace_col taille unite ((abs+unite),ord))
in
  trace_col n u (0,0);;



(******fonction permettant de tracer un carre vide ou plein 
  avec une couleur choisie(rouge,vert,bleu)******)
(*abs et ord sont les coordonnees du coin superieur gauche du carre et 
  visible dit si le carre a construire est plein ou non*)
 
(* pour afficher en gris le fond de l'ecran *)
let carre_plein
    (abs:int) (ord:int)
    (unite:int) 
    (visible:bool) 
    (drawing :('a GDraw.drawable)) 
    (couleur:string) =
              drawing#set_foreground (`NAME  couleur);
              drawing#rectangle  ~filled:(visible) ~x:(abs) ~y:(ord) ~width:unite ~height:unite ();;





 

(* calcule la figure  afficher (figure option) conformment  un champ d'une donne (qui peut tre absent, un entier ou un vecteur) *)
let figure_rect chan unite c x_min y_min d =
  if not (Data.exists_champ chan d) 
  then None
  else
    let valeur =(Data.get_champ chan d) 
	(*On cheche la valeur associe au champ*)
    and (x,y) = (Data.get_pos d)

    in 
      (
	match valeur with 
	   Data.Int v->
              let triplet= 
		int_of_float3( mult_couleur (255.0 *.( float_of_int v)) c)
		(*il faut faire une translation*)
	      and abs=(x-x_min)*unite  (* position absolue dans le dessin*)
	      and ord=(y-y_min)*unite
	      in
		Some(Carre( (abs, ord), unite, triplet))
          | Data.Vect(dx,dy) -> 
	      let triplet= int_of_float3( mult_couleur (255.0 *. 255.0) c)
		(*il faut faire une translation*)
	      and abs=(x-x_min)*unite + unite/2  
	      and ord=(y-y_min)*unite + unite/2
	      in 
	      let abs' = abs+dx*unite
	      and ord' = ord+dy*unite 
	      in
	      Some(Ligne  ( (abs, ord), (abs', ord'), triplet))
      )
      
(* calcule toutes les figures  afficher pour un champ dans une scene *)
let figures  ch unite c xmin ymin (s:Types.scene) = 
  let f = (fun e -> fun r -> 
    match (figure_rect ch unite c xmin ymin e) with 
      None -> r 
    | Some f -> f :: r)
  in List.fold_right f  s []



