(* File lexer.mll *)

{
  open Parser       
}

let digit = ['0'-'9']
let champ = ['A'-'Z' 'a'-'z' '\'' '`'] ['A'-'Z' 'a'-'z' '0'-'9' '_']*


rule vocab = 
   parse
 
  | "{"                            {  LACCOL }
  | "}"                            {  RACCOL } 
  | "["                            { LCROCH  }
  | "]"                            { RCROCH  }
  | "="                            { EGAL    } 
  | ","                            { VIRG   } 
  | ";"                            { VIRG   } 
  
  | "grille"                       { GRILLE }
  | "grid"                         { GRILLE }
  | "hexa"                         { HEXA   }
  | "coord"                        { COORD } 
  | "true"                         { INT (255)}
  | "false"                        { INT (0)}
  | "message"                      { MESS }
  
  | eof                            { EOF }
  | digit+'.'digit+                { INT (int_of_float(float_of_string(Lexing.lexeme lexbuf)))}
  |digit+                          { INT(int_of_string(Lexing.lexeme lexbuf)) }
  |"-"digit+                          { INT(int_of_string(Lexing.lexeme lexbuf)) }
 
  | champ+                          { STRING    (Lexing.lexeme lexbuf)  }
  | [' ' '\t' '\n']+                { vocab lexbuf }     (* skip blanks *)

  | '"'[^'"']*'"'                   { STRING (let s =  (Lexing.lexeme lexbuf) 
					      in String.sub s 1 (String.length s -2))    }

