(*****************fonctions de manipulation sur les listes*****************)
open Types ;;

(*On prend en entree une liste d'enregistrements correspondant a une scene et donne les maximums (x,y)*)

(* max_couple : 'a * 'b -> 'a * 'b -> 'a * 'b *)
let max_couple (a1,b1) (a2,b2) = ((max a1 a2),(max b1 b2));;
(* min_couple : 'a * 'b -> 'a * 'b -> 'a * 'b *)
let min_couple (a1,b1) (a2,b2) = ((min a1 a2),(min b1 b2));;


(* max_ll prend une scene
   et donne la valeur maximale de posx et posy en un couple d'entiers *)
(*********max_ll: enregistrement list -> int * int *********)
let  max_ll s = 
  let rec cherche_max ( (max_x : int) ,max_y) = function
  []  ->  (max_x,max_y)
    |h::t  ->   
       
       begin
         let (abs,ord)=(Data.get_pos  h)
	 in
         let couple=((max max_x abs),(max max_y ord))
         in
           (cherche_max couple t)
       end
	 
  in    (cherche_max (0, 0) s)
;;

(*De meme pour les minimums de posx et de posy*)
(*(string * int) list list -> int * int*)
let  min_ll liste = 
  let rec cherche_min (min_x,min_y) = function
  []   ->  (min_x,min_y)
 |h::t  -> 
                       begin
                        let (abs,ord)=(Data.get_pos h)
                        in
                          let couple=((min min_x abs),(min min_y ord))
                          in
                            (cherche_min couple t)
                       end
             in
    (cherche_min (0,0) liste) 
;;

(**** fonctions qui recherche les maximums et les minimums pour posx et posy 
  dans une data list list ****)
(*max_maille : data list list -> int * int*)
let rec max_maille  = function
        [] -> failwith "il n'y a aucune scene ds la liste"
       |a::[] -> (max_ll a)
       |h::t -> (max_couple (max_maille t)(max_ll h))
;; 
(*De meme pour les minimums*)
(*min_maille : (string * int) list list list -> int * int*)
let rec min_maille  = function
        [] -> failwith "il n'y a aucun element ds la liste"
       |a::[] -> (min_ll a)
       |h::t -> (min_couple (min_maille t)(min_ll h))
;;



(***********fonctions servant a recuperer les champ dans la liste de la sortie du parser*********************)


let rec fusion l1=function
	[]->l1
      |e::l2->
	  if List.mem e l1
	  then fusion l1 l2
	  else e::fusion l1 l2;; 


(*fonction finalle pour recuperer tout les champ d'une (string*int) list list list*)
(*liste_champs : (string * 'a) list list list -> string list*)
let liste_champs_scene s  = 
  let tous_champs = List.map Data.liste_champs s
  in List.fold_right fusion  tous_champs [];;
 
let liste_champs seq  = 
  let tous_champs = List.map liste_champs_scene seq
  in List.fold_right fusion  tous_champs [];;



