(* THIS FILE WILL NEVER BE OVERWRITTEN.
Use it as a template for your own main module.*)
open GMain
open Liste
open Types


(*class customized_callbacks = object(self)
inherit Project5_glade_callbacks.default_callbacks
end*)

let _ = Arg.parse [ 
  ("-t",
   Arg.Int (fun n -> (Parametres.refreshSpeed:=n)),
   "Minimal update rate (ms)") ;

  ("-png",
   Arg.Set Parametres.capture,
   "Capture images as PNG files") ;

  ("-svg",
   Arg.String (fun s -> Parametres.svgoutput := Some s),
   "produces an SVG output file")

    

 ] 
(fun _ -> ()) (Parametres.titre ^ "\nReads on standard input.") ;; 

let main () = 

     let (message,topologie,scene) = Parser.main Lexer.vocab Parametres.lexbuf
     in

       (* si le mode de reperage est Seq, on donne des coordonnes *)
     

     let callbacks = new Callbacks.callbacks (topologie,scene) in
     let window1 = new Project5_glade_interface.top_window1 callbacks in
       (* You should probably remove the next line if you want to use the event masks from glade *)
     let _ = GtkBase.Widget.add_events window1#window1#as_widget [`ALL_EVENTS] 
     and list_cha =(liste_champs [scene])
     in
       
       begin
	 (match message with
	      None -> () 
	    | Some s -> print_endline s
	 ) ;

	 (* NB : je commence par afficher une fenetre car lors du changement des valeurs 
	  * des widgets, des evenements sont lances, pouvant provoquer un affichage,
	  * qui va planter si la fenetre n'existe pas *)
	 callbacks#new_drawing ;
	 window1#window1#set_title Parametres.titre ;
	 window1#window1#show() ;

         window1#combo_champs1#set_popdown_strings (list_cha)  ;
         window1#combo_champs2#set_popdown_strings (list_cha) ;
	 window1#combo_champs3#set_popdown_strings (list_cha) ;
	 
	 window1#entry_rouge1#set_text "1.00" ;
	 window1#entry_vert1#set_text "0.00" ;
	 window1#entry_bleu1#set_text "0.00" ;
	 
	 window1#entry_rouge2#set_text "0.00" ;
	 window1#entry_vert2#set_text "1.00" ;
	 window1#entry_bleu2#set_text "0.00" ;
	 
	 window1#entry_rouge3#set_text "0.00" ;
	 window1#entry_vert3#set_text "0.00" ;
	 window1#entry_bleu3#set_text "1.00" ;
	 
	 window1#entry_rouge_grille#set_text"0.00" ;
	 window1#entry_vert_grille#set_text "0.00" ;
	 window1#entry_bleu_grille#set_text "0.00" ;
	 
	 window1#entry_rouge_fond#set_text "1.00" ;
	 window1#entry_vert_fond#set_text "1.00" ;
	 window1#entry_bleu_fond#set_text "1.00" ;
	 
	 
	 callbacks#new_drawing ;
	 window1#window1#show() ;
	 Main.main ()
       end ;;

let _ = 
  let locale = GtkMain.Main.init () 
  in (* Change to [GtkThread.start ()] to use threads *)
    Printexc.print main () ;;
    
